#include <hitachi.mac>

width   EQU 4Dh
height  EQU 4Eh
decwid  EQU 4Fh
arr     EQU 51h
count   EQU 53h

                      OS BT$PPRG
                      DB 07h
                      XGDX               ;get parameters
                      LDD 2,X
                      STD width
                      LDX 0,X
                      STX arr
                      DEX
                      DEX
                      DEX
                      LDAB 0,X
                      STAB decwid

;Copy right column over length bytes on left
;and copy left column to right hand side. Declared width must be at least
;one byte longer than actual width!
                      LDX arr
                      LDAB height
lrcopy                PSHB
                      LDAA 1,X
                      PSHX
                      LDAB width
                      ABX
                      STAA 1,X
                      LDAA 0,X
                      PULX
                      STAA 0,X
                      LDAB decwid
                      ABX
                      INX
                      PULB
                      DECB
                      BNE lrcopy
                      
;Copy top two rows to bottom
                      LDAB decwid
                      CLRA
                      ASLD
                      ADDD %2
                      STD 41h
                      XGDX
                      LDX arr
                      OS UT$CPYB
                      
;Calculate new generation (save in high bits).
                      LDX arr
                      LDAB height        ;for each row
c3                    PSHB
                      LDAB width         ;for each cell in row
c2                    PSHB
                      LDAB decwid
                      PSHX
                      LDAA 0,X           ;add all neighbouring cells
                      ADDA 1,X
                      ADDA 2,X
                      ABX
                      PSHX
                      ADDA 1,X
                      ADDA 3,X
                      ABX
                      ADDA 2,X
                      ADDA 3,X
                      ADDA 4,X
                      PULX
                      ANDA %7Fh
                      LDAB 2,X
                      RORB
                      RORB
                      SUBA %2         ;If 2 neighbours then no change
                      BEQ nx
                      CLRB
                      DECA            ;If not 3 then die, 
                      BNE nx
                      ORAB %80h        ;else new cell born
nx                    ORAB 2,X
                      STAB 2,X
                      PULX
                      INX             ;Move right
                      PULB            
                      DECB
                      BNE c2          ;Loop till line done
                      LDAB decwid
                      SUBB width
                      INCB
                      ABX             ;Move to start of next line
                      PULB
                      DECB
                      BNE c3          ;Loop till all lines done
                      
;Copy one row from bottom to top
                      LDAB decwid
                      CLRA
                      XGDX
                      INX
                      STX 41h
                      LDX arr
                      XGDX
                      OS UT$CPYB



;Activate new generation, and restore length bytes on left
                      CLRA
                      CLRB
                      STD count
                      LDX arr
                      LDAB height
a3                    PSHB            ;For each line
                      LDAB width
                      STAB 0,X        ;restore length byte
a2                    CLRA            ;Update cell
                      ROL 1,X
                      ROLA
                      STAA 1,X
                      BEQ empty       ;If not empty,
                      PSHX            ; then increase count
                      LDX count
                      INX
                      STX count
                      PULX
empty                 INX             ;Move right
                      DECB            
                      BNE a2          ;Loop till done
                      LDAB decwid
                      SUBB width
                      INCB
                      ABX             ;move to start of next line
                      PULB
                      DECB            ;Loop till all lines done
                      BNE a3

;return number of cells present
                      LDX count
                      OS BT$PPRG
                      DB 87h
